
import java.util.*;
import java.io.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.util.*;

public class HTMLJavaDocTask extends Javadoc {
    private File depsrc = null;
    public void setDepsrc(File dir) {
        depsrc = dir;
    }
    
    private File depdest = null;
    public void setDestdir(File dir) {
        super.setDestdir(dir);
        depdest = dir;
    }
    
    public void execute() throws BuildException {
        DirectoryScanner scanner = new DirectoryScanner();
        scanner.setBasedir(depsrc);
        scanner.setIncludes(new String[] { "**/*.java" });
        scanner.scan();
        String[] files = scanner.getIncludedFiles();
        
        MergingMapper mapper = new MergingMapper();
        mapper.setTo(new File(depdest, "index.html").toString());
        
        files = new SourceFileScanner(this).restrict(files, depsrc, depdest, mapper);
        if (files.length > 0) {
            super.execute();
        }
    }
}

