
import java.util.*;
import java.util.regex.*;
import java.io.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.util.*;

public class MetaTextTask extends MatchingTask {
    private File base;
    public void setSrcdir(File dir) {
        base = dir;
    }
    
    private File destination;
    public void setDestdir(File dir) {
        destination = dir;
    }
    
    public void execute() throws BuildException {
        try {
            String[] filenames = getDirectoryScanner(base).getIncludedFiles();
            FileNameMapper mapper = new FileNameMapper() {
                public void setFrom(String from) {
                }
                public void setTo(String to) {
                }
                private String[] EMPTY = new String[0];
                public String[] mapFileName(String filename) {
                    String str = ".meta.";
                    int index = filename.indexOf(str);
                    if (index < 0)
                        return EMPTY;
                    for (;;) {
                        filename = filename.substring(0, index) + "." + filename.substring(index + str.length());
                        index = filename.indexOf(str);
                        if (index < 0)
                            break;
                    }
                    return new String[] { filename };
                }
            };
            filenames = new SourceFileScanner(this).restrict(filenames, base, destination, mapper);
            if (filenames.length > 0) {
                for (int i = 0; i < filenames.length; i++) {
                    String filename = filenames[i];
                    File src = new File(base, filename);
                    File dst = new File(destination, mapper.mapFileName(filename)[0]);
                    System.out.println("from " + src + " to " + dst);
                    new MetaText(src, dst, getOwningTarget().getProject().getProperties());
                }
            }
        } catch (Exception x) {
            if (x instanceof BuildException) {
                throw (BuildException) x;
            } else {
                throw new BuildException(x);
            }
        }
    }
}

